#define MADE "v. 4.00,---> Jan 10th 2015"

#include "Main.h"
#include "TTimer.h"
#include "hw.h"

/////////////timing stuff//////////////

#include <sys/time.h>
#include <string.h>
#include <TGraph.h>
#include <TMath.h>

//////////////////////////////////////
#ifndef ROOT_TGDockableFrame
#include "TGDockableFrame.h"
#endif
#ifndef ROOT_TGMenu
#include "TGMenu.h"
#endif
#ifndef ROOT_TGMdiDecorFrame
#include "TGMdiDecorFrame.h"
#endif
#ifndef ROOT_TG3DLine
#include "TG3DLine.h"
#endif
#ifndef ROOT_TGMdiFrame
#include "TGMdiFrame.h"
#endif
#ifndef ROOT_TGMdiMainFrame
#include "TGMdiMainFrame.h"
#endif
#ifndef ROOT_TGMdiMenu
#include "TGMdiMenu.h"
#endif
#ifndef ROOT_TGColorDialog
#include "TGColorDialog.h"
#endif
#ifndef ROOT_TGListBox
#include "TGListBox.h"
#endif
#ifndef ROOT_TGNumberEntry
#include "TGNumberEntry.h"
#endif
#ifndef ROOT_TGScrollBar
#include "TGScrollBar.h"
#endif
#ifndef ROOT_TGComboBox
#include "TGComboBox.h"
#endif
#ifndef ROOT_TGuiBldHintsEditor
#include "TGuiBldHintsEditor.h"
#endif
#ifndef ROOT_TGuiBldNameFrame
#include "TGuiBldNameFrame.h"
#endif
#ifndef ROOT_TGFrame
#include "TGFrame.h"
#endif
#ifndef ROOT_TGFileDialog
#include "TGFileDialog.h"
#endif
#ifndef ROOT_TGShutter
#include "TGShutter.h"
#endif
#ifndef ROOT_TGButtonGroup
#include "TGButtonGroup.h"
#endif
#ifndef ROOT_TGCanvas
#include "TGCanvas.h"
#endif
#ifndef ROOT_TGFSContainer
#include "TGFSContainer.h"
#endif
#ifndef ROOT_TGFontDialog
#include "TGFontDialog.h"
#endif
#ifndef ROOT_TGuiBldEditor
#include "TGuiBldEditor.h"
#endif
#ifndef ROOT_TGColorSelect
#include "TGColorSelect.h"
#endif
#ifndef ROOT_TGButton
#include "TGButton.h"
#endif
#ifndef ROOT_TGTextEdit
#include "TGTextEdit.h"
#endif
#ifndef ROOT_TGFSComboBox
#include "TGFSComboBox.h"
#endif
#ifndef ROOT_TGLabel
#include "TGLabel.h"
#endif
#ifndef ROOT_TGMsgBox
#include "TGMsgBox.h"
#endif
#ifndef ROOT_TRootGuiBuilder
#include "TRootGuiBuilder.h"
#endif
#ifndef ROOT_TGTab
#include "TGTab.h"
#endif
#ifndef ROOT_TGListView
#include "TGListView.h"
#endif
#ifndef ROOT_TGSplitter
#include "TGSplitter.h"
#endif
#ifndef ROOT_TGStatusBar
#include "TGStatusBar.h"
#endif
#ifndef ROOT_TGListTree
#include "TGListTree.h"
#endif
#ifndef ROOT_TGuiBldGeometryFrame
#include "TGuiBldGeometryFrame.h"
#endif
#ifndef ROOT_TGToolTip
#include "TGToolTip.h"
#endif
#ifndef ROOT_TGToolBar
#include "TGToolBar.h"
#endif
#ifndef ROOT_TRootEmbeddedCanvas
#include "TRootEmbeddedCanvas.h"
#endif
#ifndef ROOT_TCanvas
#include "TCanvas.h"
#endif 
#ifndef ROOT_TGuiBldDragManager
#include "TGuiBldDragManager.h"
#endif

#include "Riostream.h"

ClassImp(Main)

char name[300];

int codepointer;  // int to hold location of execution of code

char Pixie16wd[1024];

unsigned short NumModules;
unsigned short OfflineMode;   // 0 is online , 1 is offline mode

int run_no, newrun_no;
int run_nosaved; // run completed successfully for this run_no

short int moduleNr; //the module nr we are looking at 
short int channelNr;//the channel nr we are looking at

unsigned int *tracehist ;

Bool_t module_data;   // TRUE if run in progress otherwise FALSE
/////////////////////////////////////////////////////
unsigned int nFIFOWords[24];
unsigned short EndOfRunRead;
int retval;

unsigned int mod_numwordsread = 0;
long int updatecounter;
int counter;

////////////////////////////////////////////////////

short int histwin1;

////////////////////////////////////////////////////

Main::Main()
: TGMainFrame() {
}
//extern void e();
Main::Main(const TGWindow * p)
{
	///initialise variables///////////////
	moduleNr = 0;
	channelNr = 0;
	counter = 0;
	///////////////////////////////////////

codepointer = 1000; // in Main constructor
	char cwd[1024];
	if (getcwd(cwd, sizeof(cwd)) != NULL)
            fprintf(stdout, "Current working dir: %s\n", cwd);
	else
            perror("getcwd() error");

	strcpy(Pixie16wd,cwd);

        /////////////////////////////////////
	MakePanel(p);

 	fCheckButton1636->SetState(kButtonDown,kFALSE); // set checked   Auto increment run number

   fNumberEntry777->SetNumber(10);   // set initial "Run time" as 100 seconds
 //  fNumberEntry777->SetState(kFALSE); // set disabled "Run time"

  fNumberEntry1051->SetIntNumber(1);     // set initial "Run number"


mTh = 0; // TThread pointer initialised to zero

// Create a TTimer (timer called every 1000 msec)
timer = new TTimer();
timer->Connect("Timeout()", "Main",
this, "UpdateStatus()");   // UpdateStatus() is function to be run in place of DoDraw() in original code

	modNumber = 0;
	chanNumber = 0;

	t1 = 0;
	t2 = 0; 
	retval = 0;
	if(!mTh){
		  mTh= new TThread("memberfunction",(void(*)(void *))&Main::Thread1,(void*) this);
	        }
   fThreadArgs.fRun = kTRUE;
   fThreadArgs.fThread = mTh;

} // constructor of Main

Main::~Main()
{
	CloseWindow();
}

void Main::CloseWindow()
{
	gApplication->Terminate(0);
}

Bool_t Main::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2)
{
	switch (GET_MSG(msg))
	{
	case kC_COMMAND:
		switch (GET_SUBMSG(msg))
	    {
		////////////menu popups/////////////////////////////            
		case kCM_BUTTON:
			switch (parm1)
			{
			case START_BUTTON:  // START BUTTON clicked
	//	cout<<"I AM HERE 700  in START BUTTON clicked \n\n";

				// update state variables of buttons
				startbpressed = kTRUE;
				stopbpressed = kFALSE;
				brun_finished = kFALSE;   // kTRUE if run is finished
				bfinalrun_finished = kFALSE; // kTRUE if run is finished
				// update state of widgets START_BUTTON and STOP_BUTTON
				fTextButton1633->SetState( kButtonDisabled , kFALSE);
				fTextButton1634->SetState(kButtonUp , kTRUE);

		// update current state and value of widgets needed for run
			// get Run time
			trunset = fNumberEntry777->GetNumber();   // update "Run time"
			// get run no.
			run_no  = fNumberEntry1051->GetIntNumber();  // update "Run number" 
					
				// START TIMER WITH 1000 mSec time interval
				timer->Start(1000, kFALSE);   // 1000 milli-seconds REPEATED
				
				if ( histwin1 == 0 ) 
				     {
					histwin = new HistWin (fClient->GetRoot(),1000,800);  // ( ,filnam, run_no); 
				     }

				// START thread  Thread1
				printf("Starting Thread1\n");
				mTh->Run();
				break; // START BUTTON clicked

			case STOP_BUTTON:  // STOP BUTTON clicked
	//	cout<<"I AM HERE 800  in STOP BUTTON clicked \n\n";
		stopbpressed = kTRUE;
			break;    // STOP BUTTON clicked

			case SMCASPEC_BUTTON:  
				if ( histwin1 == 0 ) 
				     {
					histwin = new HistWin (fClient->GetRoot(),1000,800);
				     }
				histwin->load_datamodule(moduleNr, channelNr);
			break;    

			default:
				break;
		} // case kCM_BUTTON:switch (parm1)   
	} // case kC_COMMAND:  switch (GET_SUBMSG(msg))
	
		/////////////////default for the most inclusive switch//////////          
	default:
		break;
	} // switch (GET_MSG(msg))
	return kTRUE;
} // Bool_t Main::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2)

void Main::MakePanel(const TGWindow * q)    // (TGCompositeFrame * TabPanel)
{

//pppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp
   // main frame
   fMainFrame1777 = new TGMainFrame(q,10,10,kMainFrame | kVerticalFrame);
   fMainFrame1777->SetName("fMainFrame1777");
   fMainFrame1777->SetLayoutBroken(kTRUE);

   // composite frame
   fMainFrame1310 = new TGCompositeFrame(fMainFrame1777,638,561,kVerticalFrame);
   fMainFrame1310->SetName("fMainFrame1310");
   fMainFrame1310->SetLayoutBroken(kTRUE);

   // vertical frame
   fVerticalFrame560 = new TGVerticalFrame(fMainFrame1310,634,557,kVerticalFrame);
   fVerticalFrame560->SetName("fVerticalFrame560");
   fVerticalFrame560->SetLayoutBroken(kTRUE);

//   TGFont *ufont;         // will reflect user font changes
   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

//   TGGC   *uGC;           // will reflect user GC changes
   // graphics context changes
   GCValues_t vall1628;
   vall1628.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall1628.fForeground);
   gClient->GetColorByName("#e0e0e0",vall1628.fBackground);
   vall1628.fFillStyle = kFillSolid;
   vall1628.fFont = ufont->GetFontHandle();
   vall1628.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall1628, kTRUE);
   fLabel1628 = new TGLabel(fVerticalFrame560,"Run time :",uGC->GetGC(),ufont->GetFontStruct());
   fLabel1628->SetTextJustify(36);
   fLabel1628->SetMargins(0,0,0,0);
   fLabel1628->SetWrapLength(-1);
   fVerticalFrame560->AddFrame(fLabel1628, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1628->MoveResize(88,40,112,38);
   fNumberEntry777 = new TGNumberEntry(fVerticalFrame560, (Double_t) 0,18,-1,(TGNumberFormat::EStyle) 5);
   fNumberEntry777->SetName("fNumberEntry777");
   fVerticalFrame560->AddFrame(fNumberEntry777, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry777->MoveResize(208,48,128,20);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valButton1633;
   valButton1633.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valButton1633.fForeground);
   gClient->GetColorByName("#e0e0e0",valButton1633.fBackground);
   valButton1633.fFillStyle = kFillSolid;
   valButton1633.fFont = ufont->GetFontHandle();
   valButton1633.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valButton1633, kTRUE);

   ULong_t ucolor;        // will reflect user color changes
   gClient->GetColorByName("#00ff00",ucolor);
   fTextButton1633 = new TGTextButton(fVerticalFrame560,"Start",START_BUTTON,uGC->GetGC(),ufont->GetFontStruct());
   fTextButton1633->SetTextJustify(36);
   fTextButton1633->SetMargins(0,0,0,0);
   fTextButton1633->SetWrapLength(-1);
   fTextButton1633->Resize(152,56);

   fTextButton1633->ChangeBackground(ucolor);
   fTextButton1633->Associate(this);
   fVerticalFrame560->AddFrame(fTextButton1633, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextButton1633->MoveResize(56,112,152,56);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valButton1634;
   valButton1634.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valButton1634.fForeground);
   gClient->GetColorByName("#e0e0e0",valButton1634.fBackground);
   valButton1634.fFillStyle = kFillSolid;
   valButton1634.fFont = ufont->GetFontHandle();
   valButton1634.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valButton1634, kTRUE);

   gClient->GetColorByName("#ff0000",ucolor);
   fTextButton1634 = new TGTextButton(fVerticalFrame560,"Stop",STOP_BUTTON,uGC->GetGC(),ufont->GetFontStruct());
   fTextButton1634->SetTextJustify(36);
   fTextButton1634->SetMargins(0,0,0,0);
   fTextButton1634->SetWrapLength(-1);
   fTextButton1634->Resize(152,56);

   fTextButton1634->ChangeBackground(ucolor);
   fTextButton1634->Associate(this);
   fVerticalFrame560->AddFrame(fTextButton1634, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextButton1634->MoveResize(248,112,152,56);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valButton1635;
   valButton1635.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valButton1635.fForeground);
   gClient->GetColorByName("#e0e0e0",valButton1635.fBackground);
   valButton1635.fFillStyle = kFillSolid;
   valButton1635.fFont = ufont->GetFontHandle();
   valButton1635.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valButton1635, kTRUE);

   gClient->GetColorByName("#00ffff",ucolor);
   fTextButton1635 = new TGTextButton(fVerticalFrame560,"Show MCA Spectrum",SMCASPEC_BUTTON,uGC->GetGC(),ufont->GetFontStruct());
   fTextButton1635->SetTextJustify(36);
   fTextButton1635->SetMargins(0,0,0,0);
   fTextButton1635->SetWrapLength(-1);
   fTextButton1635->Resize(248,64);

   fTextButton1635->ChangeBackground(ucolor);
   fTextButton1635->Associate(this);
   fVerticalFrame560->AddFrame(fTextButton1635, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextButton1635->MoveResize(104,208,248,64);
   fCheckButton1636 = new TGCheckButton(fVerticalFrame560,"Auto increment Run no.",-1,uGC->GetGC(),ufont->GetFontStruct());
   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valkButton1636;
   valkButton1636.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valkButton1636.fForeground);
   gClient->GetColorByName("#e0e0e0",valkButton1636.fBackground);
   valkButton1636.fFillStyle = kFillSolid;
   valkButton1636.fFont = ufont->GetFontHandle();
   valkButton1636.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valkButton1636, kTRUE);

   gClient->GetColorByName("#ffff99",ucolor);
   fCheckButton1636->ChangeBackground(ucolor);
   fCheckButton1636->SetTextJustify(36);
   fCheckButton1636->SetMargins(0,0,0,0);
   fCheckButton1636->SetWrapLength(-1);
   fVerticalFrame560->AddFrame(fCheckButton1636, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fCheckButton1636->MoveResize(48,312,216,56);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t vall1637;
   vall1637.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall1637.fForeground);
   gClient->GetColorByName("#e0e0e0",vall1637.fBackground);
   vall1637.fFillStyle = kFillSolid;
   vall1637.fFont = ufont->GetFontHandle();
   vall1637.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall1637, kTRUE);

   gClient->GetColorByName("#ff99ff",ucolor);
   fLabel1637 = new TGLabel(fVerticalFrame560,"Run no.:",uGC->GetGC(),ufont->GetFontStruct(),kChildFrame,ucolor);
   fLabel1637->SetTextJustify(36);
   fLabel1637->SetMargins(0,0,0,0);
   fLabel1637->SetWrapLength(-1);
   fVerticalFrame560->AddFrame(fLabel1637, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1637->MoveResize(56,400,72,64);
   fNumberEntry1051 = new TGNumberEntry(fVerticalFrame560, (Int_t) 0,6,-1,(TGNumberFormat::EStyle) 0,
(TGNumberFormat::EAttribute) 1,(TGNumberFormat::ELimit) 2,0,9999); // (Double_t) 0,15,-1,(TGNumberFormat::EStyle) 5);
   fNumberEntry1051->SetName("fNumberEntry1051");
   fVerticalFrame560->AddFrame(fNumberEntry1051, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1051->MoveResize(144,424,112,20);

	fTextButton1633->SetState(kButtonUp , kFALSE);
	fTextButton1634->SetState(kButtonDisabled, kFALSE);

   fMainFrame1310->AddFrame(fVerticalFrame560, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX | kLHintsExpandY,2,2,2,2));
   fVerticalFrame560->MoveResize(2,2,634,557);

   fMainFrame1777->AddFrame(fMainFrame1310, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
   fMainFrame1310->MoveResize(0,0,638,561);

   fMainFrame1777->SetMWMHints(kMWMDecorAll,
                        kMWMFuncAll,
                        kMWMInputModeless);
   fMainFrame1777->MapSubwindows();

   fMainFrame1777->Resize(fMainFrame1777->GetDefaultSize());
   fMainFrame1777->MapWindow();
   fMainFrame1777->Resize(630,560);

}  // Main::MakeFold1Panel


void* Main::Thread1(void* arg)
{
long int loopcounteri = 0 ;

codepointer = 1001; // in Thread1
	run_nosaved = run_no ; // run completed successfully for this run_no

	while(1)   // outer loop
	{
		module_data = kTRUE ; // TRUE if run in progress otherwise FALSE

	codepointer = 1002; // in Thread1 in MCA mode outer while loop
	////////////////////////////////////////////////////////

	TThread::Lock();
	if ( histwin1 != 0 )
		{ 
		histwin->load_datamodule(moduleNr , channelNr);
		}
	TThread::UnLock();
	///////////////////timing stuff/////////////////////////////
	gettimeofday (&tim, NULL);
	t1 = tim.tv_sec + (tim.tv_usec / 1000000.0);
	while (1)  // inner loop - MCA mode
	{
	codepointer = 1003; // in Thread1 in MCA mode inner while loop
	//////////////////////timing stuff///////////////////////

	loopcounteri++;
	if (loopcounteri >= 10000000 )
		{  
			loopcounteri = 0;
			updatecounter++;
			cout << "updatecounter = " << updatecounter << "\n";
			TThread::Lock();
			if ( histwin1 != 0 )
				{ 
				histwin->load_datamodule(moduleNr , channelNr);
				}
			TThread::UnLock();
		}
	TThread::Lock();
	gettimeofday (&tim, NULL);
	t2 = tim.tv_sec + (tim.tv_usec / 1000000.0);
	trun = t2-t1;
	truntimeout = (trunset - trun);
//	cout<<"Run time: "<<(truntimeout) << " time: "<< (trun) << "\n" ;
	if ( trun >= trunset ) 
		{ timeover = kTRUE;
		}
	tstopbpressed = stopbpressed ;
	TThread::UnLock();
	if ( (timeover == kTRUE) || (tstopbpressed == kTRUE) )
		{
		brun_finished = kTRUE;
		if ( tstopbpressed == kTRUE )
		{
		bfinalrun_finished = kTRUE ;
		}
		break;
		}
	fflush(stdout);
//	fflush(stdin);
// here for each time 'brun_finished = kTRUE' write out data to file
// i.e. for each run no. write out data to file and resume for next run no.

	} //  while (1) // inner loop - MCA mode



//////**********************************************************************
//  Here update histwin display object with data 
TThread::Lock();
if ( histwin1 != 0 )
		{ 
		histwin->load_datamodule( moduleNr , channelNr );
		}
TThread::UnLock();
//////**********************************************************************
			
	codepointer = 1006; // in Thread1 outside while loop	
			// update run no widget
				if (fCheckButton1636->IsOn())  // if increment Run number check box checked 
				{  // increment run_no only after current run is over
				   // run_no++; 
				   if ( (run_no + 1) >= 9999)
					{ 
					run_no = 9998; 
					bfinalrun_finished = kTRUE;	
					}
				newrun_no = run_no + 1  ; 
				}   
				else // else leave number as it is
				    {	newrun_no = run_no ;     }
		//	fNumberEntry1051->SetIntNumber(newrun_no);     // update new run_no widget "Run number"

	if ( brun_finished == kTRUE )  // brun_finished - one run with the current run_no is finished i.e. one run_time is over
		{
		// update START_BUTTON and STOP_BUTTON states
		printf("exiting loop with run_no = %d \n",run_no);	
		timeover = kFALSE;
		if (fCheckButton1636->IsOn())  // if increment Run number check box checked 
			{  
			brun_finished = kFALSE;
			if(bfinalrun_finished != kTRUE )
				{
				run_no = newrun_no ; //  = fNumberEntry1051->GetIntNumber();  // update "Run number" 
				}
			}
		else
			{
		//	brun_finished = kTRUE; is already TRUE as per if condition above....
			bfinalrun_finished = kTRUE;
			}
	// update truntimeout widget one last time before exit as timer is already stopped
	char text333[20];
	sprintf (text333, "%.3f", trunset );
	fNumberEntry777->SetText (text333);	  // update "Run time" down-counter
	gClient->NeedRedraw(fNumberEntry777);

//

	fflush(stdout);
		} // if ( brun_finished == kTRUE )

	if ( bfinalrun_finished == kTRUE )
		{
		break;
		} // if ( bfinalrun_finished == kTRUE )
	} // while(1) // outer loop

// update START_BUTTON and STOP_BUTTON states
		printf("Finally exiting thread. run_no = %d \n",run_no);	
		timer->Stop();
		fTextButton1633->SetState(kButtonUp , kFALSE);
		fTextButton1634->SetState(kButtonDisabled, kFALSE);
		TThread::Lock();
		module_data = kFALSE ; // TRUE if run in progress otherwise FALSE
		stopbpressed = kFALSE ;
		timeover = kFALSE;
		tstopbpressed = kFALSE; // variable used in thread - thread stop button pressed
		brun_finished = kTRUE;
		bfinalrun_finished = kTRUE;
		TThread::UnLock();

	fflush(stdout);
return (void*)0;
} //  void* Main::Thread1(void* arg)

void Main::UpdateStatus()
{	// update run time widget
	char text222[20];
	sprintf (text222, "%.3f", truntimeout );
	cout << "codepointer = " << codepointer << "\n";
	fNumberEntry777->SetText (text222);	  // update "Run time" down-counterif ( brun_finished == kTRUE )
	fNumberEntry1051->SetIntNumber(newrun_no);     // update newrun_no widget with "newrun_no" number
	gClient->NeedRedraw(fNumberEntry777);
	gClient->NeedRedraw(fNumberEntry1051);
	fflush(stdout);
} // void Main::UpdateStatus()


